import 'package:flutter/material.dart';
import 'package:flutter_msg/src/store_builder.dart';
import 'package:msg/msg.dart';

extension Select<Model> on StoreBase<Model> {
  Widget select<Part>(Part Function(Model model) selector,
          Widget Function(Part part) builder) =>
      StoreBuilder<Model, Part>(
        store: this,
        selector: selector,
        builder: (_, part) => builder(part),
      );
}